SystemOrganization addCategory: 'Metacello-TestsPlatform'!

TestCase subclass: #MetacelloRepositoryGemStoneTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-TestsPlatform'!

!MetacelloRepositoryGemStoneTestCase methodsFor: 'baselines' stamp: 'DaleHenrichs 03/12/2010 01:32'!
baseline10: spec 
	<version: '1.0-baseline'>
	
	spec for: #gemstone do: [
		spec 
			package: 'Example-Core' with: [ 
				spec 
					includes: 'Example-AddOn';
					file: 'Example-Core-anon.1';
					repository: '/home/dhenrich/monticello' ]].
! !

!MetacelloRepositoryGemStoneTestCase methodsFor: 'baselines' stamp: 'DaleHenrichs 03/12/2010 01:32'!
baseline11: spec 
	<version: '1.1-baseline'>
	
	spec for: #gemstone do: [
		spec 
			package: 'Example-Core' with: [ 
				spec 
					includes: 'Example-AddOn';
					file: 'Example-Core-anon.1';
					repository: 'client://home/dhenrich/monticello' ]].
! !

!MetacelloRepositoryGemStoneTestCase methodsFor: 'baselines' stamp: 'DaleHenrichs 03/12/2010 01:32'!
baseline12: spec 
	<version: '1.2-baseline'>
	
	spec for: #gemstone do: [
		spec 
			package: 'Example-Core' with: [ 
				spec 
					includes: 'Example-AddOn';
					file: 'Example-Core-anon.1';
					repository: 'server://home/dhenrich/monticello' ]].
! !

!MetacelloRepositoryGemStoneTestCase methodsFor: 'accessing' stamp: 'DaleHenrichs 03/12/2010 01:15'!
project

	| constructor project |
	"Construct Metacello project"
	constructor := MetacelloVersionConstructor on: self.
	project := constructor project.
	project loader: MetacelloNullRecordingMCSpecLoader new.
	^project
! !

!MetacelloRepositoryGemStoneTestCase methodsFor: 'tests' stamp: 'DaleHenrichs 03/12/2010 01:28'!
testClientDirectoryRepository

	| project pkg repoSpec repo |
	project := self project.
	pkg := (project version: '1.1-baseline') packageNamed: 'Example-Core'.
	repoSpec := pkg repositorySpecs first.
	self assert: repoSpec type = 'clientDirectory'.
	repo := repoSpec createRepository.
	self assert: repo class == MCDirectoryRepository.
	self assert: repo directory pathName = '/home/dhenrich/monticello'.
	self assert: repo directory class = FileDirectory.
	
! !

!MetacelloRepositoryGemStoneTestCase methodsFor: 'tests' stamp: 'DaleHenrichs 03/12/2010 01:28'!
testDirectoryRepository

	| project pkg repoSpec repo |
	project := self project.
	pkg := (project version: '1.0-baseline') packageNamed: 'Example-Core'.
	repoSpec := pkg repositorySpecs first.
	self assert: repoSpec type = 'directory'.
	repo := repoSpec createRepository.
	self assert: repo class == MCServerDirectoryRepository.
	self assert: repo directory pathName = '/home/dhenrich/monticello'.
	self assert: repo directory class = ServerFileDirectory.
	
! !

!MetacelloRepositoryGemStoneTestCase methodsFor: 'tests' stamp: 'dkh 10/11/2011 14:07'!
testExtractAttributesFrom

	| platform input output result |
	platform := MetacelloGemStonePlatform new.
	input := {
		'2.4.5'.
		'2.5'.
		'2.4.4.1'.
		'2'.
		'2.'.
		''.
		}.
	output := { 
		#( #'gemstone' #'gs2.x' #'gs2.4.x' #'gs2.4.5.x').
		#( #'gemstone' #'gs2.x' #'gs2.5.x' ).
		#( #'gemstone' #'gs2.x' #'gs2.4.x' #'gs2.4.4.x' #'gs2.4.4.1.x').
		#( #'gemstone' #'gs2.x' ).
		#( #'gemstone' #'gs2.x' ).
		#( #'gemstone' ).
		}.
	1 to: input size do: [:index |
		result := platform extractAtrributesFrom: (input at: index).
		self assert: result = (output at: index) ].! !

!MetacelloRepositoryGemStoneTestCase methodsFor: 'tests' stamp: 'DaleHenrichs 03/12/2010 01:29'!
testServerDirectoryRepository

	| project pkg repoSpec repo |
	project := self project.
	pkg := (project version: '1.2-baseline') packageNamed: 'Example-Core'.
	repoSpec := pkg repositorySpecs first.
	self assert: repoSpec type = 'serverDirectory'.
	repo := repoSpec createRepository.
	self assert: repo class == MCServerDirectoryRepository.
	self assert: repo directory pathName = '/home/dhenrich/monticello'.
	self assert: repo directory class = ServerFileDirectory.
	
! !
